package dbBase

import (
	"fmt"
	"log"
	"os"
	"testing"
)

func TestDbLink(t1 *testing.T) {

	InitDb("10.28.20.101", "5190", "TESTDB", "SYSDBA", "SYSDBA")
	db := GetDb()
	defer db.Close()

}

func TestIns(t1 *testing.T) {

	InitDb("10.28.20.101", "5190", "TESTDB", "SYSDBA", "SYSDBA")
	db := GetDb()
	defer db.Close()
	a := "<# /home/gtong/xugu_work/xgtest/file/test_pic_1.png;"
	ExecString(db, fmt.Sprintf("insert into t3 values(%s,'a');", a))
}

func TestInsPrepare(t1 *testing.T) {

	InitDb("10.28.20.101", "5190", "TESTDB", "SYSDBA", "SYSDBA")
	db := GetDb()
	defer db.Close()
	var args []interface{}
	// 读取图像文件
	imageData, err := os.ReadFile("/home/gtong/xugu_work/xgtest/file/test_pic_1.png")
	if err != nil {
		log.Fatal(err)
	}

	stmt, err := db.Prepare("insert into t3 values(?,'a')")
	if err != nil {
		log.Fatal(err)
	}
	args = append(args, imageData)
	_, err = stmt.Exec(args...)
	if err != nil {
		log.Fatal(err)
	}

	stmt.Close()
}

func TestInsPrepare2(t1 *testing.T) {

	InitDb("10.28.20.101", "5190", "TESTDB", "SYSDBA", "SYSDBA")
	db := GetDb()
	defer db.Close()
	abc := []string{" ../../file/test.txt"}
	ExecPrepareString(db, "     insert into t3 values(?,'a');", abc)
}
